libdc1394: dc1394/format7.h File Reference

libdc1394 2.2.7

Data Structures | Typedefs | Functions
format7.h File Reference

Functions to control Format_7 (aka scalable format, ROI). More...

`#include <dc1394/log.h>`
`#include <dc1394/video.h>`

## Data Structures
struct | __dc1394format7mode_t
struct | __dc1394format7modeset_t

## Typedefs
typedef struct __dc1394format7mode_t | dc1394format7mode_t
typedef struct __dc1394format7modeset_t | dc1394format7modeset_t

## Functions
dc1394error_t | dc1394_format7_get_max_image_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *h_size, uint32_t *v_size)
dc1394error_t | dc1394_format7_get_unit_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *h_unit, uint32_t *v_unit)
dc1394error_t | dc1394_format7_get_image_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *width, uint32_t *height)
dc1394error_t | dc1394_format7_set_image_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t width, uint32_t height)
dc1394error_t | dc1394_format7_get_image_position (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *left, uint32_t *top)
dc1394error_t | dc1394_format7_set_image_position (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t left, uint32_t top)
dc1394error_t | dc1394_format7_get_unit_position (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *h_unit_pos, uint32_t *v_unit_pos)
dc1394error_t | dc1394_format7_get_color_coding (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394color_coding_t *color_coding)
dc1394error_t | dc1394_format7_get_color_codings (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394color_codings_t *codings)
dc1394error_t | dc1394_format7_set_color_coding (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394color_coding_t color_coding)
dc1394error_t | dc1394_format7_get_color_filter (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394color_filter_t *color_filter)
dc1394error_t | dc1394_format7_get_packet_parameters (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *unit_bytes, uint32_t *max_bytes)
dc1394error_t | dc1394_format7_get_packet_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *packet_size)
dc1394error_t | dc1394_format7_set_packet_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t packet_size)
dc1394error_t | dc1394_format7_get_recommended_packet_size (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *packet_size)
dc1394error_t | dc1394_format7_get_packets_per_frame (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *ppf)
dc1394error_t | dc1394_format7_get_data_depth (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *data_depth)
dc1394error_t | dc1394_format7_get_frame_interval (dc1394camera_t *camera, dc1394video_mode_t video_mode, float *interval)
dc1394error_t | dc1394_format7_get_pixel_number (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint32_t *pixnum)
dc1394error_t | dc1394_format7_get_total_bytes (dc1394camera_t *camera, dc1394video_mode_t video_mode, uint64_t *total_bytes)
dc1394error_t | dc1394_format7_get_modeset (dc1394camera_t *camera, dc1394format7modeset_t *info)
dc1394error_t | dc1394_format7_get_mode_info (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394format7mode_t *f7_mode)
dc1394error_t | dc1394_format7_set_roi (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394color_coding_t color_coding, int32_t packet_size, int32_t left, int32_t top, int32_t width, int32_t height)
dc1394error_t | dc1394_format7_get_roi (dc1394camera_t *camera, dc1394video_mode_t video_mode, dc1394color_coding_t *color_coding, uint32_t *packet_size, uint32_t *left, uint32_t *top, uint32_t *width, uint32_t *height)

## Detailed Description

Functions to control Format_7 (aka scalable format, ROI).

More details soon

## Typedef Documentation

## ◆ dc1394format7mode_t

typedef struct __dc1394format7mode_t dc1394format7mode_t

A struct containing information about a mode of Format_7, the scalable image format.

## ◆ dc1394format7modeset_t

typedef struct __dc1394format7modeset_t dc1394format7modeset_t

A struct containing the list of Format_7 modes. FIXME: this may become very big if format_7 pages are used in IIDC 1.32. It would be better to use a "num" and an allocated list.

## Function Documentation

## ◆ dc1394_format7_get_color_coding()

dc1394error_t dc1394_format7_get_color_coding | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394color_coding_t * | color_coding )

Gets the current color coding

## ◆ dc1394_format7_get_color_codings()

dc1394error_t dc1394_format7_get_color_codings | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394color_codings_t * | codings )

Gets the list of color codings available for this mode

## ◆ dc1394_format7_get_color_filter()

dc1394error_t dc1394_format7_get_color_filter | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394color_filter_t * | color_filter )

Gets the current color filter

## ◆ dc1394_format7_get_data_depth()

dc1394error_t dc1394_format7_get_data_depth | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | data_depth )

Gets the data depth (e.g. 12, 13, 14 bits/pixel)

## ◆ dc1394_format7_get_frame_interval()

dc1394error_t dc1394_format7_get_frame_interval | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | float * | interval )

Gets the frame interval in float format

## ◆ dc1394_format7_get_image_position()

dc1394error_t dc1394_format7_get_image_position | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | left,
|  | uint32_t * | top )

Gets the current image position

## ◆ dc1394_format7_get_image_size()

dc1394error_t dc1394_format7_get_image_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | width,
|  | uint32_t * | height )

Gets the current image size.

## ◆ dc1394_format7_get_max_image_size()

dc1394error_t dc1394_format7_get_max_image_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | h_size,
|  | uint32_t * | v_size )

Gets the maximal image size for a given mode.

## ◆ dc1394_format7_get_mode_info()

dc1394error_t dc1394_format7_get_mode_info | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394format7mode_t * | f7_mode )

Gets the properties of a Format_7 mode

## ◆ dc1394_format7_get_modeset()

dc1394error_t dc1394_format7_get_modeset | ( | dc1394camera_t * | camera,
|  | dc1394format7modeset_t * | info )

Gets the properties of all Format_7 modes supported by the camera.

## ◆ dc1394_format7_get_packet_parameters()

dc1394error_t dc1394_format7_get_packet_parameters | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | unit_bytes,
|  | uint32_t * | max_bytes )

Get the parameters of the packet size: its maximal size and its unit size. The packet size is always a multiple of the unit bytes and cannot be zero.

## ◆ dc1394_format7_get_packet_size()

dc1394error_t dc1394_format7_get_packet_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | packet_size )

Gets the current packet size

## ◆ dc1394_format7_get_packets_per_frame()

dc1394error_t dc1394_format7_get_packets_per_frame | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | ppf )

Gets the number of packets per frame.

## ◆ dc1394_format7_get_pixel_number()

dc1394error_t dc1394_format7_get_pixel_number | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | pixnum )

Gets the number of pixels per image frame

## ◆ dc1394_format7_get_recommended_packet_size()

dc1394error_t dc1394_format7_get_recommended_packet_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | packet_size )

Gets the recommended packet size. Ignore if zero.

## ◆ dc1394_format7_get_roi()

dc1394error_t dc1394_format7_get_roi | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394color_coding_t * | color_coding,
|  | uint32_t * | packet_size,
|  | uint32_t * | left,
|  | uint32_t * | top,
|  | uint32_t * | width,
|  | uint32_t * | height )

Joint function that fully gets a certain ROI taking all parameters into account.

## ◆ dc1394_format7_get_total_bytes()

dc1394error_t dc1394_format7_get_total_bytes | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint64_t * | total_bytes )

Get the total number of bytes per frame. This includes padding (to reach an entire number of packets)

## ◆ dc1394_format7_get_unit_position()

dc1394error_t dc1394_format7_get_unit_position | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | h_unit_pos,
|  | uint32_t * | v_unit_pos )

Gets the unit positions for a given mode. The image position can only be a multiple of the unit position (zero is acceptable).

## ◆ dc1394_format7_get_unit_size()

dc1394error_t dc1394_format7_get_unit_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t * | h_unit,
|  | uint32_t * | v_unit )

Gets the unit sizes for a given mode. The image size can only be a multiple of the unit size, and cannot be smaller than it.

## ◆ dc1394_format7_set_color_coding()

dc1394error_t dc1394_format7_set_color_coding | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394color_coding_t | color_coding )

Sets the current color coding

## ◆ dc1394_format7_set_image_position()

dc1394error_t dc1394_format7_set_image_position | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t | left,
|  | uint32_t | top )

Sets the current image position

## ◆ dc1394_format7_set_image_size()

dc1394error_t dc1394_format7_set_image_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t | width,
|  | uint32_t | height )

Sets the current image size

## ◆ dc1394_format7_set_packet_size()

dc1394error_t dc1394_format7_set_packet_size | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | uint32_t | packet_size )

Sets the current packet size

## ◆ dc1394_format7_set_roi()

dc1394error_t dc1394_format7_set_roi | ( | dc1394camera_t * | camera,
|  | dc1394video_mode_t | video_mode,
|  | dc1394color_coding_t | color_coding,
|  | int32_t | packet_size,
|  | int32_t | left,
|  | int32_t | top,
|  | int32_t | width,
|  | int32_t | height )

Joint function that fully sets a certain ROI taking all parameters into account. Note that this function does not SWITCH to the video mode passed as argument, it mearly sets it